# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## 5.0.0 (2024-03-27)

### Bug Fixes (BREAKING)

 - <csr-id-3e665df3999895329fc12920f33acaf802723424/> replace unmaintained yaml-rust 0.4 with yaml-rust2 0.8
   This may be a breaking change for some, hence the major version bump.

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 53 days passed between releases.
 - 1 commit was understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Replace unmaintained yaml-rust 0.4 with yaml-rust2 0.8 ([`3e665df`](https://github.com/byron/treediff-rs/commit/3e665df3999895329fc12920f33acaf802723424))
    - Replace unmaintained yaml-rust ([`5833bcd`](https://github.com/byron/treediff-rs/commit/5833bcd4fe7fa64a1940046e1b8b4612040b87c1))

## 4.0.3 (2024-02-03)

This release updates serde-yaml to v0.9.

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 4 commits contributed to the release over the course of 1 calendar day.
 - 847 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Release treediff v4.0.3 ([`d8ae624`](https://github.com/byron/treediff-rs/commit/d8ae624097dd82438aaa4022c1bfd8b9ca4c74df))
    - Prepare changelog prior to release ([`d61b90c`](https://github.com/byron/treediff-rs/commit/d61b90ca0dfce93d5c58567ed029ac7c319b0c8a))
    - Merge pull request #13 from glehmann/serde-yaml-09 ([`d480652`](https://github.com/byron/treediff-rs/commit/d480652f79a9853340dfdfed462b195400a4255f))
    - Update serde_yaml to 0.9 ([`3177d4a`](https://github.com/byron/treediff-rs/commit/3177d4a6fc8226fa3fdfef656f934db0b75db541))

## v4.0.2 (2021-10-09)

* update changelog

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Release treediff v4.0.2 ([`41c9caf`](https://github.com/byron/treediff-rs/commit/41c9caf8622f860a1cd782f7a450da1786be78e9))
    - Prepare changelog for next release ([`716c87e`](https://github.com/byron/treediff-rs/commit/716c87eca34623dcd0ac063b07d75e241f8149eb))

## v4.0.1 (2021-10-07)

* fix links in documentation (#8)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 12 commits contributed to the release over the course of 613 calendar days.
 - 613 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Release treediff v4.0.1 ([`ebf1d8b`](https://github.com/byron/treediff-rs/commit/ebf1d8ba93e5c59425ac27f3915143c78293807b))
    - Adjusting Changelogs prior to release of treediff v4.0.1 ([`02db0ae`](https://github.com/byron/treediff-rs/commit/02db0ae6baf987e670d711eed01e69db9ca9dd42))
    - Cleanup changelog ([`20e2e0e`](https://github.com/byron/treediff-rs/commit/20e2e0e975d5257a8797455c477b45b9d8eeeea7))
    - Rename changelog to capitalized version. ([`12ad31b`](https://github.com/byron/treediff-rs/commit/12ad31ba673cee921250891d792e6f89eb5dedcf))
    - Fix broken doc comments. ([`8f28c92`](https://github.com/byron/treediff-rs/commit/8f28c9294f91296724d88a0217b8d908a4b41008))
    - Fix serde_yaml tests - for some reason it inserts newlines to key values ([`6d524b4`](https://github.com/byron/treediff-rs/commit/6d524b42f25822846f45bcd345d400c494b387ba))
    - Fix most of the clippy warnings ([`223ef3c`](https://github.com/byron/treediff-rs/commit/223ef3c8a2627ac2e564bb561799f28b883f8aa3))
    - Remove 'alpha' from next version string ([`27ec50b`](https://github.com/byron/treediff-rs/commit/27ec50ba7d38efd99d2a97a5e7d1463171a103ec))
    - Optimize imports ([`a52269e`](https://github.com/byron/treediff-rs/commit/a52269ed292315a64dcba635c4be86222b6bc416))
    - Bye bye travis, it was a good time ([`c44db69`](https://github.com/byron/treediff-rs/commit/c44db69473b837970fb555297e43eba67bddc8ad))
    - Create rust.yml ([`7bfefb5`](https://github.com/byron/treediff-rs/commit/7bfefb520ed5164004873cb54e429a3d3213f0b4))
    - (cargo-release) start next development iteration 4.0.1-alpha.0 ([`ab3a679`](https://github.com/byron/treediff-rs/commit/ab3a67951fd606c07018c7d12bfd674c90f453d8))

## v4.0.0 (2020-02-02)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Fix all lints ([`0ffb242`](https://github.com/byron/treediff-rs/commit/0ffb2428fbe7f138b022568d5b659b39037524e7))
    - Upgrade serde-yaml to the latest version ([`3bcb5bb`](https://github.com/byron/treediff-rs/commit/3bcb5bb53e55bbd4efd5eb4c81bec3ea7c876186))
    - (cargo-release) start next development iteration 3.0.3-alpha.0 ([`ffc085e`](https://github.com/byron/treediff-rs/commit/ffc085e46f729befee22e327d45ec595bd38cebc))

## v3.0.2 (2020-02-02)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 690 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Rust 2018 upgrades ([`e126c32`](https://github.com/byron/treediff-rs/commit/e126c32cdfdff2f598a09dfdd45e192f27ae50a7))
    - Remove clog; smaller package ([`176cd69`](https://github.com/byron/treediff-rs/commit/176cd69361b19fd882386cb797be8ba467047404))

## v3.0.1 (2018-03-12)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 1 commit contributed to the release.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Make filter_mut() actually return a mutable reference ([`cbb1b06`](https://github.com/byron/treediff-rs/commit/cbb1b06745397ec05503b20542c7839e0c55ca19))

## v3.0.0 (2018-03-11)

* **upgrade**: use latest versions of dependencies

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release over the course of 87 calendar days.
 - 168 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Update to latest versions of dependencies ([`0517e7c`](https://github.com/byron/treediff-rs/commit/0517e7cfa60256a73845a30122931c5ade389fb5))
    - Apply latest rustfmt ([`ace2602`](https://github.com/byron/treediff-rs/commit/ace26024b175c0f2ca28ecc0901a13dd3ec92158))

## v2.5.3 (2017-09-24)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release over the course of 30 calendar days.
 - 214 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Version bump ([`e0167bd`](https://github.com/byron/treediff-rs/commit/e0167bd28787375b6b2027e61ab40462e6bfa236))
    - Merge pull request #3 from paulrouget/serde_bump ([`dbac9ec`](https://github.com/byron/treediff-rs/commit/dbac9ec4f02714a8c016d4658b404a6cee1b035c))
    - Serde version bump ([`fe8f02a`](https://github.com/byron/treediff-rs/commit/fe8f02a857ec17c6bd05b7a2f717d2ab50242e3a))

## v2.5.1 (2017-02-22)

<csr-id-6092375279e6fe184c8b457f0e6eb5a9f7f05d3b/>

### Other

 - <csr-id-6092375279e6fe184c8b457f0e6eb5a9f7f05d3b/> use serde 0.9.8 and Map::Entry
* **upgrade:**  use serde 0.9.8 and Map::Entry ([60923752](https://github.com/Byron/treediff-rs/commit/6092375279e6fe184c8b457f0e6eb5a9f7f05d3b))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 7 days passed between releases.
 - 1 commit was understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Update changelog ([`323a20f`](https://github.com/byron/treediff-rs/commit/323a20fa362c1f01cef00dc1d9bc19995adc621a))
    - Use serde 0.9.8 and Map::Entry ([`6092375`](https://github.com/byron/treediff-rs/commit/6092375279e6fe184c8b457f0e6eb5a9f7f05d3b))

## v2.5.0 (2017-02-14)

<csr-id-75fae1b2c30b9ce42012f1c9d63118e0443b9b6f/>

### Other

 - <csr-id-75fae1b2c30b9ce42012f1c9d63118e0443b9b6f/> allow keys to be cloned and displayed
* **merger:**  allow keys to be cloned and displayed ([75fae1b2](https://github.com/Byron/treediff-rs/commit/75fae1b2c30b9ce42012f1c9d63118e0443b9b6f))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 1 commit was understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - V2.5.0 ([`727ed22`](https://github.com/byron/treediff-rs/commit/727ed22fddba6a58ec654db1b0474f7a8f8c9444))
    - Allow keys to be cloned and displayed ([`75fae1b`](https://github.com/byron/treediff-rs/commit/75fae1b2c30b9ce42012f1c9d63118e0443b9b6f))

## v2.4.0 (2017-02-14)

<csr-id-eeb3a2da52c22d7e820fe3a40c74e55a2431ff9e/>
<csr-id-fc210ea42354be6e8febcd210bd9630040bd357d/>

### Other

 - <csr-id-eeb3a2da52c22d7e820fe3a40c74e55a2431ff9e/> method to obtain mutable borrow to filter
 - <csr-id-fc210ea42354be6e8febcd210bd9630040bd357d/> method to obtain immutable reference to filter.
* **merger:**
  *  method to obtain mutable borrow to filter ([eeb3a2da](https://github.com/Byron/treediff-rs/commit/eeb3a2da52c22d7e820fe3a40c74e55a2431ff9e))
  *  method to obtain immutable reference to filter. ([fc210ea4](https://github.com/Byron/treediff-rs/commit/fc210ea42354be6e8febcd210bd9630040bd357d))
*  method to obtain immutable reference to filter. ([fc210ea4](https://github.com/Byron/treediff-rs/commit/fc210ea42354be6e8febcd210bd9630040bd357d))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 2 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - V2.4.0 ([`960d01c`](https://github.com/byron/treediff-rs/commit/960d01c122bd51f2e120aa59217feae7fee77731))
    - Method to obtain mutable borrow to filter ([`eeb3a2d`](https://github.com/byron/treediff-rs/commit/eeb3a2da52c22d7e820fe3a40c74e55a2431ff9e))
    - Method to obtain immutable reference to filter. ([`fc210ea`](https://github.com/byron/treediff-rs/commit/fc210ea42354be6e8febcd210bd9630040bd357d))

## v2.3.0 (2017-02-13)

<csr-id-07eff4f93816bc10d4b0d5d98bcaef03741ee2c0/>
<csr-id-981c94afe98cd1da11aed290562ebe4a1e7a60cc/>

### Other

 - <csr-id-07eff4f93816bc10d4b0d5d98bcaef03741ee2c0/> handle possiblity of underflow
 - <csr-id-981c94afe98cd1da11aed290562ebe4a1e7a60cc/> add AsRef implementation
* **Merger:**  add AsRef implementation ([981c94af](https://github.com/Byron/treediff-rs/commit/981c94afe98cd1da11aed290562ebe4a1e7a60cc))
* **safety:**  handle possiblity of underflow ([07eff4f9](https://github.com/Byron/treediff-rs/commit/07eff4f93816bc10d4b0d5d98bcaef03741ee2c0))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 2 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Update changelog ([`49cdef0`](https://github.com/byron/treediff-rs/commit/49cdef0719b3824f5c58f0eda65be18728bde84a))
    - Handle possiblity of underflow ([`07eff4f`](https://github.com/byron/treediff-rs/commit/07eff4f93816bc10d4b0d5d98bcaef03741ee2c0))
    - Add AsRef implementation ([`981c94a`](https://github.com/byron/treediff-rs/commit/981c94afe98cd1da11aed290562ebe4a1e7a60cc))

## v2.2.0 (2017-02-13)

* `yaml_rust` support, for both `diff` and `merge`.

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Bump to version 2.2 ([`3c0dc31`](https://github.com/byron/treediff-rs/commit/3c0dc310456aa6a6e8b0dd1d9fe90c183ccf98ae))
    - Support for yaml-rust ([`88b632d`](https://github.com/byron/treediff-rs/commit/88b632d0e3906680fd22f0fd3ea7ab7f077f5f65))

## v2.1.1 (2017-02-13)

<csr-id-f06102825d04bf245b5ff2ee931e8a45b94e9dd3/>

### Other

 - <csr-id-f06102825d04bf245b5ff2ee931e8a45b94e9dd3/> fix links
* fix library documentation links

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 1 commit contributed to the release.
 - 1 commit was understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Fix links ([`f061028`](https://github.com/byron/treediff-rs/commit/f06102825d04bf245b5ff2ee931e8a45b94e9dd3))

## v2.1.0 (2017-02-13)

* `serde_yaml` support, for both `diff` and `merge`.

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 6 days passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Mutator/merge support for serde-yaml ([`5e44fe9`](https://github.com/byron/treediff-rs/commit/5e44fe965d163ea5a833ddebe468759177f31083))
    - Prepare merge tests for Yaml ([`e132c25`](https://github.com/byron/treediff-rs/commit/e132c25fc0117ffcc540772725867be7ebb536f7))
    - Add diff support for serde-yaml ([`8e14a85`](https://github.com/byron/treediff-rs/commit/8e14a85f15a323f27d2ed3866c1bad6dd206053a))

## v2.0.1 (2017-02-07)

<csr-id-4dc2032561593cee1a41f2371396fade9687906c/>

### Other

 - <csr-id-4dc2032561593cee1a41f2371396fade9687906c/> categories!
* **cargo:**  categories! ([4dc20325](https://github.com/Byron/treediff-rs/commit/4dc2032561593cee1a41f2371396fade9687906c))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 1 commit was understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Update changelog ([`ed7c873`](https://github.com/byron/treediff-rs/commit/ed7c87357a6ac8a59b962bbd7ce8ab63b3639bca))
    - Categories! ([`4dc2032`](https://github.com/byron/treediff-rs/commit/4dc2032561593cee1a41f2371396fade9687906c))
    - Say goodbye to git-journal, welcome back clog ([`67797d3`](https://github.com/byron/treediff-rs/commit/67797d328e1adc1d22268cb5b3a95d73fe221a74))

## v2.0.0 (2017-02-07)

Improve `Merger` API considerably, and make it even more powerful.

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release over the course of 1 calendar day.
 - 1 day passed between releases.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Bumped version to v2.0 ([`a579c1c`](https://github.com/byron/treediff-rs/commit/a579c1c051dabd0846a495cbeadef1b70a4987e7))
    - Improved merger API ([`e6512e2`](https://github.com/byron/treediff-rs/commit/e6512e2c5e820bcd8b577bcbf69a20a5ceecc0e9))
    - Added doc link to Readme ([`d84c44f`](https://github.com/byron/treediff-rs/commit/d84c44f7c0794a513a43b57e9ddf613f13a9cde8))

## v1.0.0 (2017-02-05)

Initial release.

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 74 commits contributed to the release over the course of 23 calendar days.
 - 0 commits were understood as [conventional](https://www.conventionalcommits.org).
 - 0 issues like '(#ID)' were seen in commit messages

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Changed version to v1.0.0 ([`958a1f3`](https://github.com/byron/treediff-rs/commit/958a1f344e4117573377e0be9b0c665eba5d2034))
    - Added all remaining docs ([`f17d671`](https://github.com/byron/treediff-rs/commit/f17d671b106b119c0118919c3e03754cf2524f21))
    - Improved crate structure ([`5d0c76e`](https://github.com/byron/treediff-rs/commit/5d0c76ed5af54ed5b2ac5fd5a76ddbb499f1c0d8))
    - Added even more docs/structural changes ([`b463311`](https://github.com/byron/treediff-rs/commit/b463311ce49bec69d32ea31dc841fcd71b3083c8))
    - Improved module layout ([`367aaf4`](https://github.com/byron/treediff-rs/commit/367aaf4178ac6c161e4403f0507499f10f444c48))
    - Added docs for main traits ([`2d6a8a8`](https://github.com/byron/treediff-rs/commit/2d6a8a8b84b7180b22f70fff3f815f688d1f03db))
    - Removed unnecessary options in API ([`a370969`](https://github.com/byron/treediff-rs/commit/a370969dc958467b4be432681c3cf34aece14150))
    - Added some more docs ([`ea88d65`](https://github.com/byron/treediff-rs/commit/ea88d651ef1343e30f1bb7a561e23ffacbe8e103))
    - Added support for value removal on conflict ([`1195299`](https://github.com/byron/treediff-rs/commit/1195299f46321f7f84e5f618232383ca95a2e8d8))
    - Added some crate docs ([`17fd836`](https://github.com/byron/treediff-rs/commit/17fd836d45f6f38c400994d0912b4a1a248b89f4))
    - Improved project structure ([`5abc89d`](https://github.com/byron/treediff-rs/commit/5abc89d1349b79f0a20bff26fd5ae9c761450fda))
    - Improved suite definitions ([`96d3b98`](https://github.com/byron/treediff-rs/commit/96d3b986548ffeb49d118cfefb4761b9aee96f8a))
    - Added Merge support for serde-json ([`f932d4a`](https://github.com/byron/treediff-rs/commit/f932d4aa58bf8e32303b2188156f635cee2ee3e8))
    - Improved API to support arbitrary modifications when merging ([`038256d`](https://github.com/byron/treediff-rs/commit/038256d62bc9999524c96b0d6da7a5122f70a8f3))
    - Improved API by using Cow only when needed ([`773cd1b`](https://github.com/byron/treediff-rs/commit/773cd1b6cf07ee5a8aa828b505126874a0d977e6))
    - Added support for deletion handler ([`a298c50`](https://github.com/byron/treediff-rs/commit/a298c506bff6647ec9aae65ac7f38042c31e6e32))
    - Added test to verify conflict resolver. ([`46f766a`](https://github.com/byron/treediff-rs/commit/46f766a82407027143e55fabe473e77fbadeb5ee))
    - Improved delegate clarity and capability of resolve() ([`d4eae6a`](https://github.com/byron/treediff-rs/commit/d4eae6a8154f6c189bac99cacfc4b5258275f633))
    - Improved delegate interface consistency ([`1bcd40a`](https://github.com/byron/treediff-rs/commit/1bcd40a03baf942460df22f504aded5e69f0a0f5))
    - Added groundwork for resolving conflicts ([`5630e87`](https://github.com/byron/treediff-rs/commit/5630e87c6d9f18f1f4b720e452aa234b6a0c3f59))
    - Added generalized suite for merge tests ([`d146dba`](https://github.com/byron/treediff-rs/commit/d146dba4de3b66b552c9e8f0b59000776768b88f))
    - Improved json value tests ([`fa1bf24`](https://github.com/byron/treediff-rs/commit/fa1bf241eded74b5a651276e7d8b9c776aeac43e))
    - Added diff support for serde_json Value ([`cf1934a`](https://github.com/byron/treediff-rs/commit/cf1934a31fa05a86c750eae9ad51fe8732aa28d6))
    - Added json value suite ([`1070cd4`](https://github.com/byron/treediff-rs/commit/1070cd40611ac7ad0e79beab5bb94c0e8e7551ee))
    - Changed structure in preparation for serde ([`ef34105`](https://github.com/byron/treediff-rs/commit/ef34105cb3a0e700fb908c7eed07e3d9dce17190))
    - Added remove_key support for json ([`0b12455`](https://github.com/byron/treediff-rs/commit/0b12455afd7aeb828133d8258e872631e5200e88))
    - Changed license to MIT/Apache2 ([`b734959`](https://github.com/byron/treediff-rs/commit/b734959e42e9ea3801d11e3f695c6f7bc2edbf5a))
    - Added handling for merging arrays ([`3749007`](https://github.com/byron/treediff-rs/commit/374900700ee05957d0b5b975c7253d128adc22db))
    - Improved object setter code ([`c141b92`](https://github.com/byron/treediff-rs/commit/c141b92f053dfad09a023ee74a301fcc97d89d6b))
    - Improved mergeable trait to not degenerate information ([`d448e7c`](https://github.com/byron/treediff-rs/commit/d448e7c6bc3d7c40259e3eee4522e47dbe6cb40d))
    - Added key removal and modification for merge ([`d19b005`](https://github.com/byron/treediff-rs/commit/d19b005b0bc7770dae3a4c5c2fc679dfff44f93e))
    - Added added-key tests and impl ([`52cb2b6`](https://github.com/byron/treediff-rs/commit/52cb2b6fe2fa8fcb9dd2fbd76158cbbb042e6cfb))
    - Added a few tests to assert Mergeable.set() ([`e1d2c14`](https://github.com/byron/treediff-rs/commit/e1d2c14f3aaf329b8426b4513d11524a83fd5634))
    - Added merge infrastructure ([`4347535`](https://github.com/byron/treediff-rs/commit/4347535a962ba16b280f265b5dc23bd423b47541))
    - Improved key ownership ([`627ba19`](https://github.com/byron/treediff-rs/commit/627ba19d5e6d38dea75b72e59fbcc4613044817f))
    - Added full key support ([`843d18b`](https://github.com/byron/treediff-rs/commit/843d18bd64daaa4637b254e25e2d70fa5903d17d))
    - Added preliminary key support ([`70101cc`](https://github.com/byron/treediff-rs/commit/70101ccd3a9fdd81d3d70b39b1e5a4efaa0ad025))
    - Added handling for scalar/object comparisons ([`434b533`](https://github.com/byron/treediff-rs/commit/434b5332790625973762ea289524efac513b5c42))
    - Added implementation for nested object handling ([`86fbe0a`](https://github.com/byron/treediff-rs/commit/86fbe0a9951885a6ea78b21353113bda3db34d3a))
    - Added key addition and removal ([`41abd1e`](https://github.com/byron/treediff-rs/commit/41abd1e6452044ef8d1b75af0c2f861014b3c7ca))
    - Fixed tests ([`e7905a8`](https://github.com/byron/treediff-rs/commit/e7905a8a52a5e8b5cb68fc8e0e9f0007b69310a2))
    - Improved type definition ([`1694109`](https://github.com/byron/treediff-rs/commit/16941091bd629afb7186af3cd08928eaf1e2e800))
    - Revert "Added futile attempt to workaround type issue" ([`420e19c`](https://github.com/byron/treediff-rs/commit/420e19c2af2e31a3724c2caef790303d5f66cbbb))
    - Added futile attempt to workaround type issue ([`01a4b58`](https://github.com/byron/treediff-rs/commit/01a4b58f5fed5f02ad1f55e1f12a5606d3e024b2))
    - Added attempt to use a recursive type ([`a7eec83`](https://github.com/byron/treediff-rs/commit/a7eec832316e3e91bda1f07c7b6ff1cd6369db48))
    - Removed std entirely ([`94b8479`](https://github.com/byron/treediff-rs/commit/94b8479b691f6a203c591cb5aa78f3b35c47613b))
    - Changed diff to get closer to finding differences ([`6528fa5`](https://github.com/byron/treediff-rs/commit/6528fa57268404cf1889fb1da4a29fee924373ae))
    - Improved travis to not run unnecessary tests ([`048038d`](https://github.com/byron/treediff-rs/commit/048038de591fb9a05334135d7d2d08bd1776f063))
    - Added Value for HashMap ([`60ef3cf`](https://github.com/byron/treediff-rs/commit/60ef3cf804308958c4650466359c6ae337d687b0))
    - Added json array value ([`b0304d1`](https://github.com/byron/treediff-rs/commit/b0304d1a959940bb17cd6a27d2d8be0104d2289d))
    - Added tests for all json scalars and the json object ([`0560d81`](https://github.com/byron/treediff-rs/commit/0560d81e824f919b9ed1011892e31e636417c6a7))
    - Added first scalar Json value ([`10b9858`](https://github.com/byron/treediff-rs/commit/10b98580430e0e56709367ffc8c105c1619c3228))
    - Added JsonKey to abstract over usize/String ([`5ac03ce`](https://github.com/byron/treediff-rs/commit/5ac03ceaa60e4a1bf42ed1375ef16e906a7cd050))
    - Added first version of json Value impl ([`837f56f`](https://github.com/byron/treediff-rs/commit/837f56f631f3c73299f3ab47d6f4fb7fd641ad65))
    - Added modification of scalar values. ([`6dee766`](https://github.com/byron/treediff-rs/commit/6dee7664a89bf701a6ef78e437a4770377f113c7))
    - Added utils module ([`42e7c3c`](https://github.com/byron/treediff-rs/commit/42e7c3c3956d2ef33f4e9805487cf71185557f12))
    - Improved Delegate to support references ([`3e31491`](https://github.com/byron/treediff-rs/commit/3e314917f309d70c4f28859f172c92458c2efa30))
    - Improved ChangeType to contain values ([`9c5904f`](https://github.com/byron/treediff-rs/commit/9c5904f86bc34739ee7efc9b773418eebee75a89))
    - Added first stub of diff function ([`01d388b`](https://github.com/byron/treediff-rs/commit/01d388b34aaaff120823e9cb005b4c07f62be386))
    - Removed with-std feature ([`d14deb4`](https://github.com/byron/treediff-rs/commit/d14deb49937fdb4ae4284fa0cf82910bad8daea3))
    - Fixed trait type signature to use iterator ([`ca6ea4e`](https://github.com/byron/treediff-rs/commit/ca6ea4e3a11c232b06ed11466246dc82fa2faf59))
    - Improved trait signature ([`569c930`](https://github.com/byron/treediff-rs/commit/569c9306028ddebad4ae151f65d53b5c9331bf41))
    - Changed trait to just copy everything ([`9f8203e`](https://github.com/byron/treediff-rs/commit/9f8203ebee60114d18c541bb9cf3f5061e0a134b))
    - Revert "Changed trait to support hacky polymorphism" ([`eb019cc`](https://github.com/byron/treediff-rs/commit/eb019cc2cb818aec67911e1d7c7c1f11d484be08))
    - Changed trait to support hacky polymorphism ([`e544f55`](https://github.com/byron/treediff-rs/commit/e544f551aa50149574b3d319057cfe2c317bcb87))
    - Improved definition of trait implementation ([`4bb8b7d`](https://github.com/byron/treediff-rs/commit/4bb8b7d51b5116d43567121e611c56d663cdc252))
    - Improved trait lifetime handling ([`8107a4c`](https://github.com/byron/treediff-rs/commit/8107a4ce13b20b36738e4a7e30f054c092a3c152))
    - Added simplified non-working items() method ([`e618706`](https://github.com/byron/treediff-rs/commit/e618706859a519d5fec8d82d7b480141c6ca0466))
    - Improved trait by simplifying it ([`c274604`](https://github.com/byron/treediff-rs/commit/c27460407aaafe97dff664a0dcf4ff411843e2cc))
    - Added attempt to create an iterator based items() method ([`edb547e`](https://github.com/byron/treediff-rs/commit/edb547e2aa5ebc0883bb44a680aac8dd3eeadb60))
    - Improved Value trait ([`26ff8d4`](https://github.com/byron/treediff-rs/commit/26ff8d445c4cd01de1aafcd8d8af654bdf96811c))
    - Added first impl of Value Trait for String ([`1822a45`](https://github.com/byron/treediff-rs/commit/1822a451a39321c2607b627de8859790a5ec41ab))
    - Added git-journal support ([`15e670a`](https://github.com/byron/treediff-rs/commit/15e670aca7ceb56de550faa00f775af14c4a7135))
    - Initial commit ([`83f2154`](https://github.com/byron/treediff-rs/commit/83f215477f57a65cbd41faaec12b82f640960967))

